/*********************************************************************
*                                                                    *          
*                              FLY                                   *
*                           --E#Y#E--				     *
*                         ===MUSCLE===                               *
*                                                                    *
*********************************************************************/
/* Header Files */
#include "fps.h"

float prevTime = 0.0;
int Frame = 1;

/*---------------------------------------------------------------------------*/

/* Init Time Counter */
void InitTimeCounter()
{
	gettimeofday(&tv0, NULL);
	FramesPerFPS = 60;
}

/*-------------------------------------------------------------------------*/

/* Update Time Counter */
void UpdateTimeCounter(float dt) 
{
	LastFrameTimeCounter = TimeCounter;
	gettimeofday(&tv, NULL);
	TimeCounter = ((float)(tv.tv_sec-tv0.tv_sec))+ 
	0.000001*((float)(tv.tv_usec-tv0.tv_usec));
	dt = TimeCounter - LastFrameTimeCounter;
}

/*-------------------------------------------------------------------------*/

/* Frames per Seconds */
void CalculateFPS() 
{
	Frame++;

	if((Frame%FramesPerFPS) == 0) 
	{
		FPS = (((float)(FramesPerFPS)) / (TimeCounter-prevTime));
		prevTime = TimeCounter;
	}
	
	printf("%4.1f seconds * %04.2f fps \n", TimeCounter, FPS);
}

/*-------------------------------------------------------------------------*/


