/*********************************************************************
*                                                                    *          
*                              FLY                                   *
*                           --E#Y#E--				     *
*                         (==MUSCLE==)                               *
*                                                                    *
*********************************************************************/

/* C Header Files */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <math.h>
/* OpenGL */
#include <GL/glew.h>
#include <GL/gl.h>
#include <GL/glx.h>
#include <GL/glu.h>
/* Flysimulator */
#include "WIN/help.h"
#include "WIN/win.h"
#include "WIN/opengl.h"
#include "WIN/cockpit.h"
#include "WIN/fps.h"

/* Define Key */
#define XK_space                         0x0020
#define XK_Escape                        0xff1b
#define XK_F1                            0xffbe
#define XK_F2                            0xffbf
#define XK_F3				 0xffc0
#define XK_F4				 0xffc1
#define XK_F5				 0xffc2
#define XK_F6				 0xffc3
#define XK_Left                          0xff51  
#define XK_Right                         0xff53  
#define XK_Up                            0xff52  
#define XK_Down                          0xff54  
#define XK_a                             0x0061
#define XK_b                             0x0062
#define XK_d                             0x0064
#define XK_e                             0x0065
#define XK_q                             0x0071 
#define XK_s                             0x0073 
#define XK_w                             0x0077
#define XK_n                             0x006e
#define XK_m                             0x006d

/* Define Bool */
#define TRUE 1
#define FALSE 0

/*-------------------------------------------------------------------------*/

char wide, texture, grid, cloud, night, fversion, fhelp = FALSE;
float dt;

/* Main Program */
int main (int egac, char **egav) 
{
	/* Console Settings */	
	int n = 0;
	int f = 0;
	
	for(n = 0; n < egac; n++)
	{
		for(f = 0; f < egav[n][f]; ++f)
		{
			switch(egav[n][f])    
			{
				case 'F':
				wide = TRUE;
				break;

				case 'T':
				texture = TRUE;
				break;
				
				case 'G':
				grid = TRUE;
				break;

				case 'C':
				cloud = TRUE;
				break;
				
				case 'N':
				night = TRUE;
				break;
				
				case 'v':
				fversion = TRUE;
				break;
				
				case 'h':
				fhelp = TRUE;
				break;
			}
		}
	}			
	
	/*------------------------------------------------------------------*/

	/* Create Window */
	createWin(wide);
	InitTimeCounter();
	loadTexture();
	
	/* Render */
	while(texture) 
	{	
		/* Landscape */
		initLand(night);
		Landscape(cloud);
		/* Cockpit */
		Speed(dt);
		Zylinder();
		Motor();
		Cockpit();
		/* Display */
		perspective();
		eventloop();
		loadFont();
		/* FPS */
		CalculateFPS();
		UpdateTimeCounter(dt);	
	}

	/*------------------------------------------------------------------*/

	/* Render */
	while(grid) 
	{	
		/* Grid */
		initGrid();
		GridView();
		/* Cockpit */
		Speed(dt);
		Zylinder();
		Motor();
		Cockpit();
		/* Display */
		perspective();
		eventloop();
		loadFont();
		/* FPS */
		CalculateFPS();
		UpdateTimeCounter(dt);	
	}

	/*------------------------------------------------------------------*/
	
	/* Show Help Desk */
	if(fhelp)
	{
		help_Desk(egac);
	}

	/* Display Version */
	else if(fversion)
	{
		version();
	}
	 
	return 0;
}

/*-------------------------------------------------------------------------*/


