/*********************************************************************
*                                                                    *          
*                              FLY                                   *
*                           --E#Y#E--   			     *
*                         ===MUSCLE===                               *
*                                                                    *
*********************************************************************/
/* Header Files */
#include "opengl.h"

/* Class */
PNG png2;
MOD mod2;
WIND wind1;
UNIFORM uniform1;

#define UNI

/* Speed */
#define sRoll		0.40f
#define sPitch		0.20f
#define sYaw		0.20f
#define sPlaneX		0.04f
#define sPlaneY		0.02f
#define sPlaneZ		0.04f

/* Plane */
GLfloat roll; 
GLfloat pitch;
GLfloat yaw;
GLfloat xPlane;
GLfloat yPlane;
GLfloat zPlane;	

/* Texture */
GLubyte *bla;
GLubyte *des;
GLubyte *sea;
GLubyte *sky;

/* Matrix */
float projection[ID];
float modelview[ID];

//---------------------------------------------------------------------------

float circle[ID] = { 
		
1.0, 0.0, 0.0, 0.0, 
0.0, 1.0, 0.0, 0.0, 
0.0, 0.0, 1.0, 0.0, 
0.0, 0.0, 0.0, 1.0 };


unsigned int way[27][27] = {
	
/*A B C D E F G H I J K L M N O P Q R S T U V W X Y*/
 {0,1,1,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0, 0},
 {1,0,1,1,0,0,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0},
 {1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0, 0},
 {0,1,1,0,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0, 0},
 {0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0, 0},
 {1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0, 0},
 {0,1,0,0,0,0,1,0,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0, 0},
 {0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0, 0},
 {0,1,0,1,0,0,0,1,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,0,1,0,1,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,0,0,0,0,0,1,0,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0, 0},
 {1,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,0,0, 0},
 {0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,1,1,0,0,0, 0},
 {0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,0,0, 0},
 {0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,1,0,0,0,1,1,0,0,1,0, 0},
 {0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1, 0},
 {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,1,0,1,0, 0},
 {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,0,1,0,0, 0},
 {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0, 0},
 {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1, 0},
 {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0, 0}};
/*A B C D E F G H I J K L M N O P Q R S T U V W X Y*/


//---------------------------------------------------------------------------

/* Load Texture */
void FLY::loadTexture()
{
	/* Textures */
	char forestTex[] = "CPP/PIXEL/forest.png";
	char desertTex[] = "CPP/PIXEL/desert.png";
	char seaoceTex[] = "CPP/PIXEL/sea.png";
	char cloudTex[] = "CPP/PIXEL/cloud.png";
	
	/* Read PNG */
	png2.read_png(forestTex, &bla);		
	png2.read_png(desertTex, &des);
	png2.read_png(seaoceTex, &sea);
	png2.read_png(cloudTex, &sky);
}
	
//---------------------------------------------------------------------------

/* Load Config */
void FLY::loadConfig(char code, float config)
{
	/* Config */
	FILE *configFile=fopen("CPP/DATA/config.fs","r");
	while(fscanf(configFile,"%s %f", &code, &config)!= EOF)
	{ 
		code = config;
	}
	fclose(configFile);
}

//---------------------------------------------------------------------------

/* Init Grid */
void FLY::initGrid()
{	
	/* Background Color */
	glEnable(GL_BLEND);	
	glEnable(GL_DEPTH_TEST);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glClearColor( 0.01f , 0.01f , 0.01f , 0.5f );
}

//---------------------------------------------------------------------------

/* Init Landscape */
void FLY::initLand(bool night)
{	
	/* Background Color */
	glEnable(GL_BLEND);
	glEnable(GL_AMBIENT);
	glEnable(GL_LIGHT7);
	glEnable(GL_LIGHTING);	
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_COLOR_MATERIAL);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	
	/* Night */
	if(night)
	{	
		glClearColor( 0.10f , 0.20f , 0.30f , 0.5f );
		glDisable(GL_LIGHT7);	
	}

	/* Day */
	else
	{	
		glClearColor( 0.30f , 0.50f , 0.70f , 0.5f );
		glDisable(GL_LIGHTING);
	}
}

//---------------------------------------------------------------------------

/* Shader Language */
void FLY::textureShader(GLuint shader)
{	
	#ifdef UNI	
	/* Texture Shader */
	uniform1.CreateShader();
	uniform1.CreateProgram(shader);
	
	/* Init */
	uniform1.Location(shader,0, "a_Vertex");
	uniform1.Location(shader,1, "a_Color");
	uniform1.Location(shader,2, "a_TexCoord");

	/* Array */
	glEnableVertexAttribArray(0); 
    	glEnableVertexAttribArray(1);
	glEnableVertexAttribArray(2);

	/* Passing Data */
	glGetFloatv(GL_PROJECTION_MATRIX, projection);
	glGetFloatv(GL_MODELVIEW_MATRIX, modelview);
	
	/* Matrix */
	uniform1.Uniform4x4(shader, "modelview_matrix", modelview, 0);
	uniform1.Uniform4x4(shader, "projection_matrix", projection, 0);
	uniform1.Uniform(shader, "texture0", 0);
	uniform1.DeleteShader(shader);
	#endif
}

//--------------------------------------------------------------------------

/* PlaneView */
void FLY::PlaneView( GLfloat xPlane, GLfloat yPlane, GLfloat zPlane,	
		     GLfloat roll, GLfloat pitch, GLfloat yaw)
{	
	/* Rotation */
	glRotatef(-roll,  0.0f, 0.0f, 1.0f);
	glRotatef(-yaw,   0.0f, 1.0f, 0.0f);
	glRotatef(-pitch, 1.0f, 0.0f, 0.0f);
	
	/* Translate */
	glTranslatef(-xPlane, -yPlane, -zPlane);
	
	/* Multiplying Matrices */
	//glLoadMatrix(matrix[ID]);
	//glMultMatrix(matrix[ID]);
}

//--------------------------------------------------------------------------

/* Render Grid */
void FLY::GridRender(char *name)
{
	/* Load File */
	char code;
	FILE *grid;
	grid=fopen(name,"r");

        /* Grid File */
	while(fscanf(grid,"%s %f %f %f", &code, &gl.tri.x, &gl.tri.y, &gl.tri.z)!= EOF)
	{ 
		glVertex3f(gl.tri.x, gl.tri.y, gl.tri.z);
	}
	fclose(grid);
}

//--------------------------------------------------------------------------

/* Render Grid */
void FLY::GridView()
{	
	/* Render Triangles */
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	mod2.CameraLook();
	PlaneView(xPlane, yPlane, zPlane, roll, pitch, yaw);
	glLineWidth(1);
	glPointSize(5);
	
	/* Grid File */
	//char gridFileA[] = "CPP/DATA/gridA.fs";
	char gridFileB[] = "CPP/DATA/gridB.fs";
	
	/* Grid Render */
	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	glBegin(GL_POINTS);
	glColor4f(0.0f, 0.9f, 0.9f, 1.0f);	
        GridRender(gridFileB);
	glEnd();
	
	/* Grid Render */	
	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	glBegin(GL_TRIANGLES);
	glColor4f(0.7f, 0.7f, 0.7f, 1.0f);	
	GridRender(gridFileB);
	glEnd();
}

//---------------------------------------------------------------------------

/* Render Landscape */
void FLY::SubImage1(char *name, GLubyte *pixel)
{
	/* Load File */
	char code;
	FILE *land;
	land=fopen(name,"r");
        
        /* Image Data */
        glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,128,128,0,GL_BGRA,GL_UNSIGNED_BYTE,pixel);
	glTexSubImage2D(GL_TEXTURE_2D,0,0,0,128,128,GL_BGRA,GL_UNSIGNED_BYTE,pixel);	
	glTexSubImage2D(GL_TEXTURE_2D,0,2,0,128,128,GL_BGRA,GL_UNSIGNED_BYTE,pixel);
	glTexSubImage2D(GL_TEXTURE_2D,0,0,2,128,128,GL_BGRA,GL_UNSIGNED_BYTE,pixel);
	glTexSubImage2D(GL_TEXTURE_2D,0,2,2,128,128,GL_BGRA,GL_UNSIGNED_BYTE,pixel);

	/* Forest Triangles */
	glBegin(GL_TRIANGLES);
	while(fscanf(land,"%s %f %f %f %f %f", &code, &gl.tex.s, &gl.tex.t, 
		                    &gl.tri.x, &gl.tri.y, &gl.tri.z) != EOF)
	{ 	
		glTexCoord2f(gl.tex.s, gl.tex.t);
		glVertex3f(gl.tri.x, gl.tri.y, gl.tri.z);
	}
	glEnd();
	fclose(land);
}

//---------------------------------------------------------------------------

/* Render Landscape */
void FLY::SubImage2(GLubyte *pixel)
{
	/* Image Data */
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,128,128,0,GL_BGRA,GL_UNSIGNED_BYTE,pixel);
	
	/* Clouds */
	glBegin(GL_QUADS);
	glTexCoord2f(0.0,0.0);glVertex3f( 20.0f,4.0f, 20.0f);
	glTexCoord2f(2.0,0.0);glVertex3f( 20.0f,4.0f,-20.0f);
	glTexCoord2f(2.0,2.0);glVertex3f(-20.0f,4.0f,-20.0f);
	glTexCoord2f(0.0,2.0);glVertex3f(-20.0f,4.0f, 20.0f);
	glEnd();	
}

//---------------------------------------------------------------------------

/* Render Landscape */
void FLY::Landscape(bool cloud)
{	
	/* Render Triangles */
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	mod2.CameraLook();
	PlaneView(xPlane, yPlane, zPlane, roll, pitch, yaw);
	glLineWidth(1);	
	
	/* Filtering Mode */
	//glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	//glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_MIRRORED_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_MIRRORED_REPEAT);
	//glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	//glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	
	/* Landscape File */
	char forestFile[] = "CPP/DATA/forest.fs";
	char desertFile[] = "CPP/DATA/desert.fs";
	char seaoceFile[] = "CPP/DATA/seaoce.fs";
	
	/* Enable Texture */
	glEnable(GL_TEXTURE_2D);
	SubImage1(forestFile, bla);
	SubImage1(desertFile, des);
	SubImage1(seaoceFile, sea);
	
	/* Texture Cloud */
	if(cloud)
	{
		SubImage2(sky);
	}

	/* Disable Texture */	
	glDisable(GL_COLOR_MATERIAL);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	glDisable(GL_AMBIENT);
}

//---------------------------------------------------------------------------

/* Process Event */
void FLY::process_event1(XEvent report)
{ 
	KeySym key;
	key = XLookupKeysym (&report.xkey, 0);
	
	/* Keyboard Control Keys */
	switch(key)
	{	
		case XK_Left: 
		roll += sRoll; 
		break;

		case XK_Right: 
		roll -= sRoll; 
		break;

		case XK_Up: 
		pitch += sPitch; 
		break;

		case XK_Down: 
		pitch -= sPitch; 
		break;
		
		case XK_e: 
		yaw += sYaw; 
		break;

		case XK_q: 
		yaw -= sYaw; 
		break;

		case XK_a: 
		xPlane -= sPlaneX; 
		break;
		
		case XK_d: 
		xPlane += sPlaneX; 
		break;

		case XK_w: 
		yPlane += sPlaneY; 
		break;

		case XK_s: 
		yPlane -= sPlaneY; 
		break;

		case XK_b: 
		zPlane += sPlaneZ; 
		break;

		case XK_space: 
		zPlane -= sPlaneZ; 
		break;

		case XK_Escape: 
		wind1.closeWin(); 
		break;
	}
}

//---------------------------------------------------------------------------

